<?php
/* --------------------------------------------------------------
   dependent.inc.php 2018-11-07
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2018 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

/** @var \DatabaseModel $this */

// Add SHOW_PRODUCTS_MODEL_IN_SHOPPING_CART_AND_WISHLIST configuration.
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "SHOW_PRODUCTS_MODEL_IN_SHOPPING_CART_AND_WISHLIST"',
                      true);
if($check->num_rows < 1)
{
	$show_products_model = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "SHOW_PRODUCTS_MODEL"',
	                                    true);
	
	if($show_products_model->num_rows > 0)
	{
		$query     = 'INSERT INTO `gm_configuration`
              SET `gm_key`   = "SHOW_PRODUCTS_MODEL_IN_SHOPPING_CART_AND_WISHLIST",
                  `gm_value` = (SELECT `configuration_value` FROM `configuration` WHERE `configuration_key` = "SHOW_PRODUCTS_MODEL")';
		$t_success &= $this->query($query) > 0;
	}
	else
	{
		$query     = 'INSERT INTO `gm_configuration`
              SET `gm_key`   = "SHOW_PRODUCTS_MODEL_IN_SHOPPING_CART_AND_WISHLIST",
                  `gm_value` = "true"';
		$t_success &= $this->query($query) > 0;
	}
}

// Add SHOW_PRODUCTS_MODEL_IN_PRODUCT_DETAILS configuration.
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "SHOW_PRODUCTS_MODEL_IN_PRODUCT_DETAILS"', true);
if($check->num_rows < 1)
{
	$query = 'INSERT INTO `gm_configuration` SET `gm_key`   = "SHOW_PRODUCTS_MODEL_IN_PRODUCT_DETAILS", `gm_value` = "true"';
	$t_success &= $this->query($query) > 0;
}

// Add SHOW_PRODUCTS_MODEL_IN_PRODUCT_LISTS configuration.
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "SHOW_PRODUCTS_MODEL_IN_PRODUCT_LISTS"', true);
if($check->num_rows < 1)
{
	$query = 'INSERT INTO `gm_configuration` SET `gm_key`   = "SHOW_PRODUCTS_MODEL_IN_PRODUCT_LISTS", `gm_value` = "false"';
	$t_success &= $this->query($query) > 0;
}

// Create api_tokens table if it doesn't exist
$t_check = $this->table_exists('api_tokens');
if(!$t_check)
{
    $query     = '
        CREATE TABLE `api_tokens` (
            `api_tokens_id` int(11) NOT NULL AUTO_INCREMENT,
            `iss` varchar(255) NOT NULL,
            `exp` int(11) NOT NULL,
            `iat` int(11) NOT NULL,
            `customer_id` int(11) NOT NULL,
            `token` varchar(255) NOT NULL,
            PRIMARY KEY (`api_tokens_id`)
        ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
    ';
    $t_success &= $this->query($query, true);
}

// Add SHOW_RATING_AS_TAB configuration.
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "SHOW_RATING_AS_TAB"', true);
if($check->num_rows < 1)
{
    $query = 'INSERT INTO `gm_configuration` SET `gm_key`   = "SHOW_RATING_AS_TAB", `gm_value` = "true"';
    $t_success &= $this->query($query) > 0;
}

// Add SHOW_PRODUCTS_MODEL_IN_SHOPPING_CART_AND_WISHLIST configuration.
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "SHOW_PRODUCTS_MODEL_IN_SHOPPING_CART_AND_WISHLIST"',
                      true);
if($check->num_rows < 1)
{
	$query     = 'INSERT INTO `gm_configuration`
              SET `gm_key`   = "SHOW_PRODUCTS_MODEL_IN_SHOPPING_CART_AND_WISHLIST",
                  `gm_value` = (SELECT `configuration_value` FROM `configuration` WHERE `configuration_key` = "SHOW_PRODUCTS_MODEL");';
	$t_success &= $this->query($query) > 0;
}

// Add SHOW_PRODUCTS_MODEL_IN_PRODUCT_DETAILS configuration.
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "SHOW_PRODUCTS_MODEL_IN_PRODUCT_DETAILS"',
                      true);
if($check->num_rows < 1)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key`   = "SHOW_PRODUCTS_MODEL_IN_PRODUCT_DETAILS", `gm_value` = "true"';
	$t_success &= $this->query($query) > 0;
}

// Add SHOW_PRODUCTS_MODEL_IN_PRODUCT_LISTS configuration.
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "SHOW_PRODUCTS_MODEL_IN_PRODUCT_LISTS"', true);
if($check->num_rows < 1)
{
	$query     = 'INSERT INTO `gm_configuration` SET `gm_key`   = "SHOW_PRODUCTS_MODEL_IN_PRODUCT_LISTS", `gm_value` = "false"';
	$t_success &= $this->query($query) > 0;
}

// Add new columns to languages table.
$newColumnsToOldPhraseName = [
	'date_format'          => 'DATE_FORMAT',
	'date_format_long'     => 'DATE_FORMAT_LONG',
	'date_format_short'    => 'DATE_FORMAT_SHORT',
	'date_time_format'     => 'DATE_TIME_FORMAT',
	'dob_format_string'    => 'DOB_FORMAT_STRING',
	'html_params'          => 'HTML_PARAMS',
	'language_currency'    => 'LANGUAGE_CURRENCY',
	'php_date_time_format' => 'PHP_DATE_TIME_FORMAT',
];
foreach($newColumnsToOldPhraseName as $newColumn => $oldPhraseName)
{
	if(!$t_success)
	{
		break;
	}
	
	if(!$this->columnExists('languages', $newColumn))
	{
		$query     = '
			ALTER TABLE `languages`
			ADD COLUMN `' . $newColumn . '` ' . (($newColumn
		                                          === 'html_params') ? 'text NOT NULL' : 'varchar(32) NOT NULL');
		$t_success = $this->query($query);
		
		$query         = '
			SELECT *
			FROM `language_phrases_cache`
			WHERE `phrase_name` = "' . $oldPhraseName . '"
			  AND `section_name` = "language_settings";
		';
		$cachesPhrases = $this->query($query, true);
		while($cachesPhrase = $cachesPhrases->fetch_assoc())
		{
			$query     = '
				UPDATE `languages`
				SET `' . $newColumn . '` = "' . $this->real_escape_string($cachesPhrase['phrase_text']) . '"
				WHERE `languages_id` = ' . (int)$cachesPhrase['language_id'] . ';
			';
			$t_success = $this->query($query);
		}
	}
	
	// Set default cache options in configuration table in cache options deactivated.
	$t_check = $this->query('SELECT `configuration_value` FROM `configuration` WHERE `configuration_key` = "USE_CACHE" AND `configuration_value` = "false"', true);
	if($t_check->num_rows > 0)
	{
		$this->query('UPDATE `configuration` SET `configuration_value` = "false", `sort_order` = 4,`use_function` = NULL , `set_function`= "gm_cfg_select_option(array(\'true\', \'false\')," WHERE `configuration_key` = "CACHE_CHECK"');
		$this->query('UPDATE `configuration` SET `configuration_value` = 3600, `sort_order` = 3,`use_function` = NULL , `set_function`= NULL  WHERE `configuration_key` = "CACHE_LIFETIME"');
		$this->query('UPDATE `configuration` SET `configuration_value` = "false", `sort_order` = 5,`use_function` = NULL , `set_function`= "gm_cfg_select_option(array(\'true\', \'false\')," WHERE `configuration_key` = "DB_CACHE"');
		$this->query('UPDATE `configuration` SET `configuration_value` = 3600, `sort_order` = 6,`use_function` = NULL , `set_function`= NULL WHERE `configuration_key` = "DB_CACHE_EXPIRE"');
		$this->query('UPDATE `configuration` SET `configuration_value` = "cache", `sort_order` = 2,`use_function` = NULL , `set_function`= NULL WHERE `configuration_key` = "DIR_FS_CACHE"');
		$this->query('UPDATE `configuration` SET `configuration_value` = "false", `sort_order` = 1,`use_function` = NULL , `set_function`= "gm_cfg_select_option(array(\'true\', \'false\')," WHERE `configuration_key` = "USE_CACHE"');
		$this->query('UPDATE `configuration` SET `configuration_value` = "true", `sort_order` = 7,`use_function` = NULL , `set_function`= "gm_cfg_select_option(array(\'true\', \'false\')," WHERE `configuration_key` = "HTTP_CACHING"');
	}
}

// Add SpecialOfferApiV2Controller and ProductPricesApiV2Controller as group item to AdminAccess.
$productGroup = $this->getAdminAccessGroupIdByIdentifier('PAGE', 'categories.php');
if((int)$productGroup > 0)
{
	$this->addAdminAccessGroupItem($productGroup, 'CONTROLLER', 'SpecialOffersApiV2');
	$this->addAdminAccessGroupItem($productGroup, 'CONTROLLER', 'ProductPricesApiV2');
}

// Add ParcelServicesApiV2Controller and TrackingCodeApiV2Controller as group item to AdminAccess.
$parcelServiceGroup = $this->getAdminAccessGroupIdByIdentifier('PAGE', 'parcel_services.php');
if((int)$parcelServiceGroup > 0)
{
	$this->addAdminAccessGroupItem($parcelServiceGroup, 'CONTROLLER', 'ParcelServicesApiV2');
	$this->addAdminAccessGroupItem($parcelServiceGroup, 'CONTROLLER', 'TrackingCodeApiV2');
}

$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "MODULE_CENTER_GAMBIODIRECTHELP_INSTALLED"', true);
if($check->num_rows == 0)
{
	$query = "insert into `gm_configuration` (gm_key, gm_value, gm_group_id, gm_sort_order) values ('MODULE_CENTER_GAMBIODIRECTHELP_INSTALLED', '1', '0', '0')";
	$t_success &= $this->query($query, true);
}

$check = $this->query("SELECT * FROM `configuration_storage` WHERE `key` = 'modules/GambioDirectHelp/active'", true);
if($check->num_rows == 0)
{
	$query = "insert into `configuration_storage` (`key`, `value`) values ('modules/GambioDirectHelp/active', '1')";
	$t_success &= $this->query($query, true);
}

$check = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "USE_BUSTFILES"', true);
if(!$check->num_rows)
{
	$query = 'INSERT INTO `configuration` (`configuration_key`,`configuration_value`,`configuration_group_id`,`sort_order`,`use_function`,`set_function`,`date_added`)
              VALUES ("USE_BUSTFILES", "false", 14, 5, NULL, "gm_cfg_select_option(array(\'true\', \'false\'),", NOW())';
	$t_success &= $this->query($query) > 0;
}

$check = $this->table_column_exists('languages', 'status_admin');
if(!$check)
{
	$query = 'ALTER TABLE `languages` ADD `status_admin` TINYINT UNSIGNED NOT NULL DEFAULT "1" AFTER `status`';
	
	$t_success &= $this->query($query, true);
}

/**
 * Add new Content Manager contents
 */
function addContent($id, array $titles, array $texts, &$success, $db)
{
	$groupIds = '';
	
	$t_check = $db->query("SELECT * FROM `configuration` WHERE `configuration_key` = 'GROUP_CHECK' AND `configuration_value` = 'true'", true);
	if($t_check->num_rows === 1)
	{
		$groupIds = 'c_all_group,';
		
		$customerStatusIds = $db->query('SELECT DISTINCT `customers_status_id` FROM `customers_status` ORDER BY `customers_status_id`');
		foreach($customerStatusIds as $customerStatusId)
		{
			$groupIds .= 'c_' . $customerStatusId['customers_status_id'] . '_group,';
		}
	}
	
	$languages = $db->query('SELECT `languages_id` FROM `languages`');
	foreach($languages as $language)
	{
		/**
		 * Add Header Content
		 */
		$check = $db->query('SELECT * FROM `content_manager`
								WHERE `languages_id` = ' . $language['languages_id'] . '
									AND `content_group` = ' . $id, true);
		if($check->num_rows == 0)
		{
			$query = 'INSERT INTO `content_manager`
						SET
							`languages_id` = ' . $language['languages_id'] . ',
							`group_ids` = "' . $groupIds  . '",
							`file_flag` = 1,
							`content_status` = 0,
							`content_group` = ' . $id . ',
							`content_delete` = 0,
							`protected` = 1,
							`gm_sitemap_entry` = 0';
			$success &= $db->query($query, true);
			
			if($language['languages_id'] == 1)
			{
				$content_title = $titles[0];
				$content_text  = $texts[0];
			}
			else
			{
				$content_title = $titles[1];
				$content_text  = $texts[1];
			}
			
			$query = 'UPDATE `content_manager`
							SET
								`content_title` = "' . $content_title . '",
								`content_heading` = "' . $content_title . '",
								`content_text` = "' . $content_text . '"
						WHERE
							`content_group` = ' . $id . '
							AND `languages_id` = ' . $language['languages_id'];
			$success &= is_numeric($db->query($query));
		}
	}
}

addContent(
	3300001,
	[
		'Loss of session',
		'Sitzung unterbrochen',
	],
	[
		'For PayPal payments to work as expected it is essential that your browser sends a session identification (session cookie) when returning from PayPal authorization. Your browser did not send this identification, therefore your shopping session has been terminated. Please deactivate any &ldquo;anti virus&rdquo; or &ldquo;internet security&ldquo; software you may be running on your computer. Afterwards, you can log in to the shop system again and continue your shopping experience.<br />',
		'F&uuml;r das korrekte Funktionieren der Zahlung &uuml;ber PayPal ist es notwendig, dass Ihr Browser bei der R&uuml;ckkehr in den Shop nach der PayPal-Autorisierung weiterhin die Kennung der zuvor verwendeten Sitzung (Session-Cookie) sendet. Dies erfolgt gegenw&auml;rtig nicht. Ein m&ouml;glicher Grund k&ouml;nnte die Verwendung von &bdquo;Antiviren&ldquo;-Software oder sonstiger &bdquo;Internet Security&ldquo;-Software sein. Bitte deaktivieren Sie daher derlei Einflussfaktoren. Anschlie&szlig;end k&ouml;nnen Sie sich erneut in den Shop einloggen und Ihren Einkauf fortsetzen.<br />',
	],
	$t_success,
	$this
);

// Ensure that disconnected Hub clients have the "False" HubConnector status set, in order to avoid unnecessary requests towards Hub. 
$check_configuration = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "MODULE_PAYMENT_GAMBIO_HUB_STATUS" AND `configuration_value` = "True"', true);
$check_gm_configuration = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GAMBIO_HUB_CLIENT_KEY" AND `gm_value` = ""', true);
if($check_configuration->num_rows > 0 && $check_gm_configuration->num_rows > 0)
{
	$query = ' 
        UPDATE `configuration` SET
            `configuration_value` = "False"
        WHERE
            `configuration_key` = "MODULE_PAYMENT_GAMBIO_HUB_STATUS"';
	
	$t_success &= $this->query($query) > 0;
}

if(method_exists($this, 'getAdminAccessGroupIdByIdentifier'))
{
	$adminAccessGroupId = $this->getAdminAccessGroupIdByIdentifier('CONTROLLER', 'HubConfiguration');
	$this->addAdminAccessGroupItem($adminAccessGroupId, 'CONTROLLER', 'GambioHub');
	$this->addAdminAccessGroupItem($adminAccessGroupId, 'CONTROLLER', 'KlarnaHub');
	$this->addAdminAccessGroupItem($adminAccessGroupId, 'CONTROLLER', 'PaymentMatchingHub');
	$this->addAdminAccessGroupItem($adminAccessGroupId, 'CONTROLLER', 'KlarnaHubSettlements');
}

// Add CATEGORY_UNFOLD_DEFAULT_LEVEL configuration.
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "CATEGORY_UNFOLD_DEFAULT_LEVEL"', true);
if($check->num_rows < 1)
{
	$query = 'INSERT INTO `gm_configuration` SET `gm_key`   = "CATEGORY_UNFOLD_DEFAULT_LEVEL", `gm_value` = "10"';
	$t_success &= $this->query($query) > 0;
}

if(!function_exists('insertGoogleConfigIfNotExist'))
{
    function insertGoogleConfigIfNotExist($db, $scope, $option, $default = '\"\"')
    {
        $query = 'SELECT * FROM `google_configurations` WHERE `scope` = "' . $scope . '" AND `option` = "' . $option
                 . '"';
        
        $result = $db->query($query, true);
        
        if($result->num_rows < 1)
        {
            $query = 'INSERT INTO `google_configurations` (`scope`, `option`, `value`) VALUES ("' . $scope . '","'
                     . $option . '","{\"value\":' . $default . '}")';
            
            return $db->query($query) !== false;
        }
        
        return true;
    }
}

if(!$this->table_exists('google_configurations'))
{
    $query     = 'CREATE TABLE `google_configurations` (
	`scope`         ENUM ("general", "adwords", "shopping", "analytics", "auth") NOT NULL,
	`option`        VARCHAR(255)                                         NOT NULL,
	`value`         VARCHAR(255)                                         NOT NULL,
	`last_modified` TIMESTAMP                                            NOT NULL DEFAULT CURRENT_TIMESTAMP
	ON UPDATE CURRENT_TIMESTAMP,
	PRIMARY KEY (`scope`, `option`)
)
	ENGINE = InnoDB
	DEFAULT CHARSET = `utf8`';
    $t_success &= $this->query($query, true);
}

if(!$this->table_exists('google_adwords_client_customers'))
{
    $query     = 'CREATE TABLE `google_adwords_client_customers` (
  `client_customer_id` varchar(12) NOT NULL,
  `primary` int(1) NOT NULL DEFAULT "0",
  PRIMARY KEY (`client_customer_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ';
    $t_success &= $this->query($query, true);
}

// check and try to export old google configuration values
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GOOGLE_ADWORDS_CONNECTION_STATUS"', true);
if($check->num_rows === 1)
{
    $connectionStatus = $this->query('SELECT `gm_value` FROM `gm_configuration` WHERE `gm_key` = "GOOGLE_ADWORDS_CONNECTION_STATUS"');
    
    $connected = array_key_exists(0, $connectionStatus)
                 && $connectionStatus[0]['gm_value'] === 'true' ? 'true' : 'false';
    
    $query     = 'DELETE FROM `gm_configuration` WHERE `gm_key` = "GOOGLE_ADWORDS_CONNECTION_STATUS"';
    $t_success &= $this->query($query, true);
    
    $check = $this->query('SELECT * FROM `google_configurations` WHERE `scope` = "general" AND `option` = "connection-status"',
        true);
    
    if($check->num_rows < 1)
    {
        $query     = 'REPLACE INTO `google_configurations` (`scope`, `option`, `value`) VALUES
			("general", "connection-status", "{\"value\": ' . $connected . '}")';
        $t_success &= $this->query($query, true);
    }
}

$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GOOGLE_ADWORDS_REFRESH_TOKEN"', true);
if($check->num_rows === 1)
{
    $refreshTokenResult = $this->query('SELECT `gm_value` FROM `gm_configuration` WHERE `gm_key` = "GOOGLE_ADWORDS_REFRESH_TOKEN"');
    $refreshToken       = array_key_exists(0, $refreshTokenResult) ? $refreshTokenResult[0]['gm_value'] : '';
    
    $query     = 'DELETE FROM `gm_configuration` WHERE `gm_key` = "GOOGLE_ADWORDS_REFRESH_TOKEN"';
    $t_success &= $this->query($query, true);
    
    $check = $this->query('SELECT * FROM `google_configurations` WHERE `scope` = "auth" AND `option` = "refresh-token"',
        true);
    
    if($check->num_rows < 1)
    {
        $query     = 'REPLACE INTO `google_configurations` (`scope`, `option`, `value`) VALUES
			("auth", "refresh-token", "{\"value\": \"' . $refreshToken . '\"}")';
        $t_success &= $this->query($query, true);
    }
}

insertGoogleConfigIfNotExist($this, 'general', 'connection-status', 'false');
insertGoogleConfigIfNotExist($this, 'auth', 'refresh-token');
insertGoogleConfigIfNotExist($this, 'auth', 'access-token');
insertGoogleConfigIfNotExist($this, 'auth', 'expiration-timestamp');
insertGoogleConfigIfNotExist($this, 'analytics', 'ua-tracking-code');
insertGoogleConfigIfNotExist($this, 'analytics', 'enabled', 'false');
insertGoogleConfigIfNotExist($this, 'analytics', 'anonymize-ip', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'price-net', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'box-impression-tracking', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'listing-impression-tracking', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'product-click-tracking', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'product-details-tracking', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'shopping-cart-tracking', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'checkout-tracking', 'true');
insertGoogleConfigIfNotExist($this, 'analytics', 'dev-mode', 'false');
insertGoogleConfigIfNotExist($this, 'analytics', 'box-bestseller-name', '\"Bestseller Box\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'box-specials-name', '\"Specials Box\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'box-whats-new-name', '\"Whats New Box\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'list-bestseller-name', '\"Bestseller List\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'list-specials-name', '\"Specials List\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'list-new-products-name', '\"New Products List\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'list-whats-new-name', '\"Whats New List\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'list-available-soon-name', '\"Available Soon List\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'list-top-products-name', '\"Top Products List\"');
insertGoogleConfigIfNotExist($this, 'analytics', 'gtag-js-file-name');
insertGoogleConfigIfNotExist($this, 'analytics', 'analytics-js-file-name');
insertGoogleConfigIfNotExist($this, 'analytics', 'ec-plugin-js-file-name');
insertGoogleConfigIfNotExist($this, 'adwords', 'conversion-tracking-enabled', 'false');
insertGoogleConfigIfNotExist($this, 'adwords', 'conversion-name');
insertGoogleConfigIfNotExist($this, 'adwords', 'conversion-id');
insertGoogleConfigIfNotExist($this, 'adwords', 'conversion-action-id');

if(method_exists($this, 'addAdminAccessGroup'))
{
	// add google backend controller to admin access
	$latestSortOrder = $this->query('SELECT `sort_order` FROM `admin_access_groups` ORDER BY `sort_order` DESC LIMIT 1');
	$sortOrder       = (int)$latestSortOrder['sort_order'] + 1;
	
	$insertedGroupIds = [];
	
	$check = $this->query('SELECT * FROM `admin_access_group_items` WHERE `type` = "CONTROLLER" AND `identifier` = "GoogleShopping"',
	                      true);
	
	if($check->num_rows < 1)
	{
		$groupId = $this->addAdminAccessGroup(array(1 => 'Google Shopping', 2 => 'Google Shopping'), array(
			1 => 'Allows the usage of Google Shopping.',
			2 => 'Erlaubt die Nutzung von Google Shopping.',
		), $sortOrder++, 10);
		if($groupId !== false)
		{
			$t_success          &= $this->addAdminAccessGroupItem($groupId, 'CONTROLLER', array(
				'GoogleShopping',
				'GoogleShoppingAjax',
			));
			$insertedGroupIds[] = $groupId;
		}
		else
		{
			$t_success = false;
		}
	}
	
	$check = $this->query('SELECT * FROM `admin_access_group_items` WHERE `type` = "CONTROLLER" AND `identifier` = "GoogleAdWords"',
	                      true);
	if($check->num_rows < 1)
	{
		$groupId = $this->addAdminAccessGroup(array(1 => 'Google Ads', 2 => 'Google Ads'), array(
			1 => 'Allows the usage of Google Ads.',
			2 => 'Erlaubt die Nutzung von Google Ads.',
		), $sortOrder++, 10);
		if($groupId !== false)
		{
			$t_success          &= $this->addAdminAccessGroupItem($groupId, 'CONTROLLER', array(
				'GoogleAdWords',
				'AdWordsCampaignsOverviewAjax',
			));
			$insertedGroupIds[] = $groupId;
		}
		else
		{
			$t_success = false;
		}
	}
	
	$check = $this->query('SELECT * FROM `admin_access_group_items` WHERE `type` = "CONTROLLER" AND `identifier` = "GoogleAnalyticsAdmin"',
	                      true);
	if($check->num_rows < 1)
	{
		$groupId = $this->addAdminAccessGroup(array(1 => 'Google Analytics', 2 => 'Google Analytics'), array(
			1 => 'Allows the usage of Google Analytics.',
			2 => 'Erlaubt die Nutzung von Google Analytics.',
		), $sortOrder++, 10);
		if($groupId !== false)
		{
			$t_success          &= $this->addAdminAccessGroupItem($groupId, 'CONTROLLER', array(
				'GoogleAnalyticsAdmin',
			));
			$insertedGroupIds[] = $groupId;
		}
		else
		{
			$t_success = false;
		}
	}
	
	$adminAccessRoles = $this->query('SELECT `admin_access_role_id` FROM `admin_access_roles`');
	
	if(is_array($adminAccessRoles))
	{
		foreach($adminAccessRoles as $adminAccessRole)
		{
			$roleId = $adminAccessRole['admin_access_role_id'];
			
			foreach($insertedGroupIds as $groupId)
			{
				$this->grantAdminAccessPermission($roleId, $groupId);
			}
		}
	}
	else
	{
		$t_success = false;
	}
}

// Mark SunnyCash as installed
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "MODULE_CENTER_GAMBIOSUNNYCASH_INSTALLED"', true);
if($check->num_rows < 1)
{
    $query = 'INSERT INTO `gm_configuration` SET `gm_key` = "MODULE_CENTER_GAMBIOSUNNYCASH_INSTALLED", `gm_value` = "1"';
    $t_success &= $this->query($query) > 0;
}

// add default GALLERY_LIGHTBOX option
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GALLERY_LIGHTBOX"', true);
if($check->num_rows < 1)
{
	$query = 'INSERT INTO `gm_configuration` SET `gm_key` = "GALLERY_LIGHTBOX", `gm_value` = "false"';
	$t_success &= $this->query($query) > 0;
}

// add default SHOW_WHATSAPP option
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "SHOW_WHATSAPP"', true);
if($check->num_rows < 1)
{
	$query = 'INSERT INTO `gm_configuration` SET `gm_key` = "SHOW_WHATSAPP", `gm_value` = "false"';
	$t_success &= $this->query($query) > 0;
}

// Add ENABLE_JS_HYPHENATION configuration.
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "ENABLE_JS_HYPHENATION"', true);
if($check->num_rows < 1)
{
	$query = 'INSERT INTO `gm_configuration` SET `gm_key` = "ENABLE_JS_HYPHENATION", `gm_value` = "false"';
	$t_success &= $this->query($query) > 0;
}