<?php
/* --------------------------------------------------------------
   dependent.inc.php 2019-02-01
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2018 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

/** @var \DatabaseModel $this */

if(!$this->columnExists('specials', 'begins_date'))
{
	$specialsBegin = 'ALTER TABLE `specials` ADD `begins_date` DATETIME NULL DEFAULT NULL AFTER `specials_last_modified`';
	$t_success &= $this->query($specialsBegin, true);
	$specialsBeginInit = 'UPDATE `specials` SET `begins_date` = NOW() WHERE `begins_date` IS NULL';
	$t_success &= $this->query($specialsBeginInit, true);
	$specialsStarted = 'ALTER TABLE `specials` ADD `started` INT(1) NOT NULL DEFAULT \'0\' AFTER `begins_date`';
	$t_success &= $this->query($specialsStarted, true);
}

// always rebuild index (recover from bugs in the block above in beta 1)
$specialsBeginIndex = 'ALTER TABLE `specials` DROP INDEX `status`, ADD INDEX `status` (`status`, `expires_date`, `begins_date`, `started`) USING BTREE';
$t_success &= $this->query($specialsBeginIndex, true);

if(!$this->columnExists('categories', 'show_categories_image_in_description'))
{
	$catImageDesc = 'ALTER TABLE `categories` ADD `show_categories_image_in_description` INT(1) NOT NULL DEFAULT \'1\' AFTER `show_sub_categories_names`';
	$t_success    &= $this->query($catImageDesc, true);
}
$this->drop_index('gm_gprint_cart_elements', 'gm_gprint_uploads_id');
$this->drop_index('gm_gprint_wishlist_elements', 'gm_gprint_uploads_id');

$customerIdsWithoutCustomerGroup = $this->query('SELECT customers_id FROM customers WHERE customers_status NOT IN (SELECT customers_status_id From customers_status)', true);

if($customerIdsWithoutCustomerGroup->num_rows > 0)
{
	$defaultCustomerGroupId = $this->query('SELECT configuration_value FROM configuration WHERE configuration_key = "DEFAULT_CUSTOMERS_STATUS_ID"')[0];
	
	foreach($customerIdsWithoutCustomerGroup as $customerId) {
		$this->query('UPDATE customers SET customers_status = ' . (int)$defaultCustomerGroupId['configuration_value']
		             . ' WHERE customers_id = ' . (int)$customerId['customers_id'], true);
	}
}

if ($this->columnExists('customers_status', 'customers_fsk18'))
{
    if (!$this->columnExists('customers_status', 'customers_fsk18_purchasable'))
    {
        $create_query = 'ALTER TABLE `customers_status` ADD `customers_fsk18_purchasable` tinyint';
        $t_success &= $this->query($create_query, true);
        $update_query = 'UPDATE `customers_status` SET `customers_fsk18_purchasable` = 1 - `customers_fsk18`';
        $t_success &= $this->query($update_query, true);
    }
    $drop_query = 'ALTER TABLE `customers_status` DROP COLUMN `customers_fsk18`';
    $t_success &= $this->query($drop_query, true);
}

/**
 * Update footer copyright year
 */
$row = $this->query("SELECT `gm_value` FROM `gm_configuration` WHERE `gm_key` = 'GM_FOOTER'");
if(!empty($row))
{
    $oldValue = $row[0]['gm_value'];
    $newValue = preg_replace('/20[\d]{2}/', '2019', $oldValue);
    $t_query  = "UPDATE `gm_configuration`
SET `gm_value` = '" . $this->coo_mysqli->real_escape_string($newValue) . "'
WHERE `gm_key` = 'GM_FOOTER'";
    $t_success &= is_numeric($this->query($t_query));
}

$check = $this->query("SELECT `gm_value`, `languages_id` FROM `gm_contents` WHERE `gm_key` = 'GM_FOOTER'");
foreach($check as $row)
{
    $oldValue = $row['gm_value'];
    $newValue = preg_replace('/20[\d]{2}/', '2019', $oldValue);
    $t_query  = "UPDATE `gm_contents`
SET `gm_value` = '" . $this->coo_mysqli->real_escape_string($newValue) . "'
WHERE `gm_key` = 'GM_FOOTER' AND `languages_id` = " . $row['languages_id'];
    $t_success &= is_numeric($this->query($t_query));
}
